[x1,fs] = audioread('pop1_short_32k.wav');
[x2,fs] = audioread('sparrow_short_32_k.wav');

x3 = zeros(size(x1));
x3(floor((length(x1)-length(x2))/2)+(1:length(x2)))=x2

x = x1/2+x3/2;

audiowrite('mix.wav',x,fs)



%[x,fs] = audioread('bat.wav');


N=512;
hop = N/2;
window = hanning(N);


pos_frame = hop+1:hop:length(x)-hop;

espectro = zeros(N,numel(pos_frame));

for i = 1:numel(pos_frame)
    frame_data = x(pos_frame(i)+(-hop:hop-1));
    espectro(:,i) = fft(frame_data.*window);    
end


imagesc(abs(espectro))
pause

x_rec = zeros(size(x));


for i = 1:numel(pos_frame)
    frame_data = ifft(espectro(:,i));
    x_rec(pos_frame(i)+(-hop:hop-1)) = x_rec(pos_frame(i)+(-hop:hop-1))+frame_data;
end

plot(x)
hold on
plot(x_rec,'r')
hold off


imwrite(log10(1+abs(espectro)),'espectro.png')

mask = double(imread('mask.png'))/255;

mask(2:end/2,:)= flipud(mask(end/2+2:end,:));
imagesc(mask)
pause

x_sep = zeros(size(x));

espectro_sep = espectro.*(1-mask);

for i = 1:numel(pos_frame)
    frame_data = ifft(espectro_sep(:,i));
    x_sep(pos_frame(i)+(-hop:hop-1)) = x_sep(pos_frame(i)+(-hop:hop-1))+frame_data;
end

plot(x)
hold on
plot(real(x_sep),'r')
hold off

audiowrite('separado.wav',real(x_sep),fs)